class SpeedTest

def initialize(ents=nil)
	ents = Sketchup.active_model.entities unless ents
puts "\nAT - SpeedTest:\n"
	time = Time.now
		@edges = 0
		@faces = 0
		@groups = 0
		@components = 0
		@construction_lines = 0
		@construction_points = 0
		@images = 0
		@section_planes = 0
		@texts = 0
		@others = 0
		scan_geometry1(ents)
	puts "is_a? - #{(Time.now - time)}c"
	
	time = Time.now
		@edges = 0
		@faces = 0
		@groups = 0
		@components = 0
		@construction_lines = 0
		@construction_points = 0
		@images = 0
		@section_planes = 0
		@texts = 0
		@others = 0
		scan_geometry2(ents)
	puts "kind_of? - #{(Time.now - time)}c"
	
	time = Time.now
		@edges = 0
		@faces = 0
		@groups = 0
		@components = 0
		@construction_lines = 0
		@construction_points = 0
		@images = 0
		@section_planes = 0
		@texts = 0
		@others = 0
		scan_geometry3(ents)
	puts "class - #{(Time.now - time)}c"

	time = Time.now
		@edges = 0
		@faces = 0
		@groups = 0
		@components = 0
		@construction_lines = 0
		@construction_points = 0
		@images = 0
		@section_planes = 0
		@texts = 0
		@others = 0
		scan_geometry4(ents)
	puts "typename - #{(Time.now - time)}c"

puts "\nModel Statistics:
   edges = #{@edges}
   faces = #{@faces}
   groups = #{@groups}
   components = #{@components}
   construction_lines = #{@construction_lines}
   construction_points = #{@construction_points}
   images = #{@images}
   section_planes = #{@section_planes}
   texts = #{@texts}
   others = #{@others}\n"

end#def

def scan_geometry1(ents)
	ents.each do |e|
		if e.is_a? Sketchup::Face
			@faces += 1
		elsif e.is_a? Sketchup::Edge
			@edges += 1
		elsif e.is_a? Sketchup::Group
			@groups += 1
			scan_geometry1(e.entities)
		elsif e.is_a? Sketchup::ComponentInstance
			@components += 1
			scan_geometry1(e.definition.entities)
		elsif e.is_a? Sketchup::ConstructionPoint
			@construction_points += 1
		elsif e.is_a? Sketchup::ConstructionLine
			@construction_lines += 1
		elsif e.is_a? Sketchup::SectionPlane
			@section_planes += 1
		elsif e.is_a? Sketchup::Image
			@images += 1
		elsif e.is_a? Sketchup::Text
			@texts += 1
		else
			@others += 1
		end
	end
end#def

def scan_geometry2(ents)
	ents.each do |e|
		if e.kind_of? Sketchup::Face
			@faces += 1
		elsif e.kind_of? Sketchup::Edge
			@edges += 1
		elsif e.kind_of? Sketchup::Group
			@groups += 1
			scan_geometry2(e.entities)
		elsif e.kind_of? Sketchup::ComponentInstance
			@components += 1
			scan_geometry2(e.definition.entities)
		elsif e.kind_of? Sketchup::ConstructionPoint
			@construction_points += 1
		elsif e.kind_of? Sketchup::ConstructionLine
			@construction_lines += 1
		elsif e.kind_of? Sketchup::SectionPlane
			@section_planes += 1
		elsif e.kind_of? Sketchup::Image
			@images += 1
		elsif e.kind_of? Sketchup::Text
			@texts += 1
		else
			@others += 1
		end
	end
end#def

def scan_geometry3(ents)
	ents.each do |e|
		if e.class == Sketchup::Face
			@faces += 1
		elsif e.class == Sketchup::Edge
			@edges += 1
		elsif e.class == Sketchup::Group
			@groups += 1
			scan_geometry3(e.entities)
		elsif e.class == Sketchup::ComponentInstance
			@components += 1
			scan_geometry3(e.definition.entities)
		elsif e.class == Sketchup::ConstructionPoint
			@construction_points += 1
		elsif e.class == Sketchup::ConstructionLine
			@construction_lines += 1
		elsif e.class == Sketchup::SectionPlane
			@section_planes += 1
		elsif e.class == Sketchup::Image
			@images += 1
		elsif e.class == Sketchup::Text
			@texts += 1
		else
			@others += 1
		end
	end
end#def

def scan_geometry4(ents)
	ents.each do |e|
		if e.typename == 'Face'
			@faces += 1
		elsif e.typename == 'Edge'
			@edges += 1
		elsif e.typename == 'Group'
			@groups += 1
			scan_geometry4(e.entities)
		elsif e.typename == 'ComponentInstance'
			@components += 1
			scan_geometry4(e.definition.entities)
		elsif e.typename == 'ConstructionPoint'
			@construction_points += 1
		elsif e.typename == 'ConstructionLine'
			@construction_lines += 1
		elsif e.typename == 'SectionPlane'
			@section_planes += 1
		elsif e.typename == 'Image'
			@images += 1
		elsif e.typename == 'Text'
			@texts += 1
		else
			@others += 1
		end
	end
end#def

end#class

#---------------------------------------------------------------------------------------------------
file_name = File.basename(__FILE__)
if not file_loaded?(file_name)
	UI.menu("Plugins").add_item("AT - SpeedTest(model)"){Sketchup.send_action("showRubyPanel:");UI.start_timer(0,false){SpeedTest.new}}
	UI.menu("Plugins").add_item("AT - SpeedTest(selection)"){Sketchup.send_action("showRubyPanel:");UI.start_timer(0,false){SpeedTest.new(Sketchup.active_model.selection)}}
	file_loaded(file_name)
end
file_name = nil